﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Threading;
using Microsoft.SCP;
using Microsoft.SCP.Rpc.Generated;

namespace LicensePlateReaderApplication
{
    public class CounterBolt : ISCPBolt
    {
        private Context ctx;

        public CounterBolt(Context ctx)
        {
            this.ctx = ctx;

            // Define input stream schema
            Dictionary<string, List<Type>> inputSchema = new Dictionary<string, List<Type>>();
            inputSchema.Add("default", new List<Type>() { typeof(LPREvent) });
            this.ctx.DeclareComponentSchema(new ComponentStreamSchema(inputSchema, null));
        }

        public static CounterBolt Get(Context ctx, Dictionary<string, Object> parms)
        {
            return new CounterBolt(ctx);
        }

        public void Execute(SCPTuple tuple)
        {
            LPREvent lprEvent = (LPREvent)tuple.GetValue(0);
            string location = lprEvent.Location.ToString();

            // Update SQL Azure table with violation counts by location
            DBHelper.UpdateCounters(location);
        }
    }
}